--- app_dial.c.orig	2011-06-13 16:56:48.147501693 -0500
+++ app_dial.c	2011-06-13 13:52:09.000000000 -0500
@@ -318,6 +318,30 @@
 	OPT_CALLER_PARK | OPT_ANNOUNCE | OPT_CALLEE_MACRO) && \
 	!chan->audiohooks && !peer->audiohooks)
 
+/* Back ported from 1.6.2 */
+int ast_datastore_free(struct ast_datastore *datastore);
+int ast_datastore_free(struct ast_datastore *datastore)
+{
+        int res = 0;
+
+        /* Using the destroy function (if present) destroy the data */
+        if (datastore->info->destroy != NULL && datastore->data != NULL) {
+                datastore->info->destroy(datastore->data);
+                datastore->data = NULL;
+        }
+
+        /* Free allocated UID memory */
+        if (datastore->uid != NULL) {
+                ast_free((void *) datastore->uid);
+                datastore->uid = NULL;
+        }
+
+        /* Finally free memory used by ourselves */
+        ast_free(datastore);
+
+        return res;
+}
+
 /* We define a custom "local user" structure because we
    use it not only for keeping track of what is in use but
    also for keeping track of who we're dialing. */
@@ -1459,6 +1483,8 @@
 		} else if (to) { /* Musta gotten hung up */
 			res = -1;
 		} else { /* Nobody answered, next please? */
+			if (!ast_channel_datastore_remove(chan, datastore))
+				ast_datastore_free(datastore);
 			res = 0;
 		}
 		/* almost done, although the 'else' block is 400 lines */

